<?php
// vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker:
/**
 * Objeto asociado a una tabla de la base de datos.
 * Parcialmente generado por DB_DataObject.
 *
 * PHP version 5
 *
 * @category  SIVeL
 * @package   SIVeL
 * @author    Vladimir Tmara <vtamara@pasosdeJesus.org>
 * @copyright 2004 Dominio pblico. Sin garantas.
 * @license   https://www.pasosdejesus.org/dominio_publico_colombia.html DP
 *            Dominio Pblico. Sin garantas.
 * @version   CVS: $Revision: 1.11.2.4 $
 * @link      http://sivel.sf.net
 * Acceso: SLO DEFINICIONES
 */

/**
 * Definicion para la tabla actocolectivo
 */
require_once 'DB_DataObject_SIVeL.php';

/**
 * Definicion para la tabla actocolectivo
 * Ver documentacin de DataObjects_Caso.
 *
 * @category SIVeL
 * @package  SIVeL
 * @author   Vladimir Tmara <vtamara@pasosdeJesus.org>
 * @license  https://www.pasosdejesus.org/dominio_publico_colombia.html DP
 *           Dominio Pblico.
 * @link     http://sivel.sf.net/tec
 * @see      DataObjects_Caso
 */
class DataObjects_Actocolectivo extends DB_DataObject_SIVeL
{
    // START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'actocolectivo';                      // table name
    var $id_p_responsable;                        // int4(4)  multiple_key
    var $id_categoria;                    // int4(4)  multiple_key
    var $id_grupoper;                 // int4(4)  multiple_key
    var $id_caso;                         // int4(4)  multiple_key

    var $nom_tabla = "Actos";

    /* the code above is auto generated do not remove the tag below */
    // END_AUTOCODE
    var $fb_preDefOrder = array('id_p_responsable');
    var $fb_fieldsToRender = array('id_p_responsable');
    var $fb_selectAddEmpty = array('id_p_responsable');
    var $fb_addFormHeader = false;
    var $fb_fieldLabels = array(
        'id_p_responsable' => 'Presunto Responsable',
        'id_categoria' => 'Categoria',
        'id_grupoper' => 'Grupo de Personas',
        'id_caso' => 'Caso'
    );

    /**
     * Ajusta formulario generado.
     *
     * @param object $form        Formulario HTML_QuickForm
     * @param object $formbuilder Generador DataObject_FormBuilder
     *
     * @return void
     */
    function postGenerateForm(&$form, &$formbuilder)
    {
        parent::postGenerateForm($form, $formbuilder);

        $t = '<table id="tablaActos" width="100%"><thead><tr>' .
            '<th>P. Responsable</th><th>Categoria</th>' .
            '<th>Vctima Colectiva</th><th></th></thead><tbody>';
        $p = clone $formbuilder->_do;
        $db = $p->getDatabaseConnection();
        $p->id_p_responsable = null;
        $p->id_categoria = null;
        $p->id_grupoper= null;
        $n = $p->find();
        while ($p->id_caso != null && $p->fetch()) {
            $pp =& $p->getLink('id_p_responsable');
            $ca =& $p->getLink('id_categoria');
            $vc =& $p->getLink('id_grupoper');
            $t .= "<tr><td>"
                . htmlentities($pp->nombre, ENT_COMPAT, 'ISO-8859-1')
                . "</td><td>"
                . htmlentities($ca->id_tipo_violencia, ENT_COMPAT, 'ISO-8859-1')
                . (int)$ca->id . " "
                . htmlentities($ca->nombre, ENT_COMPAT, 'ISO-8859-1')
                . "</td><td>"
                . htmlentities($vc->nombre, ENT_COMPAT, 'ISO-8859-1') . "</td>" .
                "<td><a href='{$_SERVER['PHP_SELF']}?eliminaactocolectivo="
                . (int)$p->id_p_responsable . ":"
                . (int)$p->id_categoria . ":"
                . (int)$p->id_grupoper
                . "'>Eliminar</a></td>";
        }
        $t .= '</tbody></table>';
        $sel =& $form->addElement('static', 'colectivas', '', $t);


    }

}

?>
