<?php
// vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker:
/**
 * Objeto asociado a una tabla de la base de datos.
 * Parcialmente generado por DB_DataObject.
 *
 * PHP version 5
 *
 * @category  SIVeL
 * @package   SIVeL
 * @author    Vladimir Tmara <vtamara@pasosdeJesus.org>
 * @copyright 2004 Dominio pblico. Sin garantas.
 * @license   https://www.pasosdejesus.org/dominio_publico_colombia.html DP
 *            Dominio Pblico. Sin garantas.
 * @version   CVS: $Revision: 1.13.2.3 $
 * @link      http://sivel.sf.net
 * Acceso: SLO DEFINICIONES
 */

/**
 * Definicion para la tabla rango_edad.
 */
require_once 'DataObjects/Basica.php';

/**
 * Definicion para la tabla rango_edad.
 * Ver documentacin de DataObjects_Basica.
 *
 * @category SIVeL
 * @package  SIVeL
 * @author   Vladimir Tmara <vtamara@pasosdeJesus.org>
 * @license  https://www.pasosdejesus.org/dominio_publico_colombia.html DP
 *           Dominio Pblico.
 * @link     http://sivel.sf.net/tec
 * @see      DataObjects_Basica
 */
class DataObjects_Rango_Edad extends DataObjects_Basica
{
    var $__table = 'rango_edad';                      // table name
    var $rango;                           // varchar(-1)  not_null
    var $limiteinferior;
    var $limitesuperior;

    var $nom_tabla = 'Rango de edad';

    var $fb_linkDisplayFields = array('rango');
    var $fb_select_display_field = 'rango';
    var $fb_linkOrderFields = array('nombre');
    var $fb_preDefOrder = array(
        'nombre',
        'rango',
        'limiteinferior',
        'limitesuperior',
        'fechacreacion',
        'fechadeshabilitacion',
    );
    var $fb_fieldsToRender = array(
        'nombre',
        'rango',
        'limiteinferior',
        'limitesuperior',
        'fechacreacion',
        'fechadeshabilitacion',
    );
    var $fb_fieldsRequired = array(
        'nombre',
        'rango',
        'limiteinferior',
        'limitesuperior',
        'fechacreacion',
    );



    /**
     * Nombres por presentar para cada campo.
     */
    var $fb_fieldLabels = array(
        'nombre' => 'Nombre',
        'Rango' => 'Rango',
        'limiteinferior' => 'Lmite Inferior',
        'limitesuperior' => 'Lmite Superior',
        'fechacreacion' => 'Fecha de Creacin',
        'fechadeshabilitacion' => 'Fecha de Deshabilitacin',
    );

    /**
     * Identificacion de registro 'SIN INFORMACIN'
     *
     * @return int Id.
     */
    static function idSinInfo()
    {
        return 6;
    }

}

?>
