<?php
// vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker:
/**
 * Objeto tabla etapa
 *
 * PHP version 5
 *
 * @category  SIVeL
 * @package   SIVeL
 * @author    Vladimir Tmara <vtamara@pasosdeJesus.org>
 * @copyright 2007 Dominio pblico. Sin garantas.
 * @license   https://www.pasosdejesus.org/dominio_publico_colombia.html DP
 *            Dominio Pblico. Sin garantas.
 * @version   CVS: $Revision: 1.11.2.4 $
 * @link      http://sivel.sf.net
 * Acceso: SLO DEFINICIONES
 */

require_once 'DataObjects/Basica.php';

/**
 * Definicion para la tabla etapa
 * Ver documentacin de DataObjects_Caso.
 *
 * @category SIVeL
 * @package  SIVeL
 * @author   Vladimir Tmara <vtamara@pasosdeJesus.org>
 * @license  https://www.pasosdejesus.org/dominio_publico_colombia.html DP
 *           Dominio Pblico.
 * @link     http://sivel.sf.net/tec
 * @see      DataObjects_Caso
 */
class DataObjects_Etapa extends DataObjects_Basica
{
    var $__table = 'etapa';                         // table name
    var $id_tipo;                              // int4(4)  not_null
    var $observaciones;                        // varchar(-1)  not_null

    var $nom_tabla = 'Etapa';

    var $fb_preDefOrder = array(
        'id',
        'id_tipo',
        'nombre',
        'observaciones',
        'fechacreacion',
        'fechadeshabilitacion',
    );
    var $fb_fieldsToRender = array(
        'id_tipo',
        'nombre',
        'observaciones',
        'fechacreacion',
        'fechadeshabilitacion',
    );
    var $fb_addFormHeader = false;
    var $fb_fieldsRequired = array(
        'id_tipo',
        'nombre',
        'fechacreacion',
    );
    var $fb_linkDisplayFields = array(
        'nombre',
        'id_tipo',
    );
    var $fb_fieldLabels = array(
        'id_tipo' => 'Tipo de proceso',
        'nombre' => 'Nombre',
        'observaciones' => 'Observaciones',
        'fechacreacion' => 'Fecha de creacin',
        'fechadeshabilitacion' => 'Fecha de deshabilitacin',
    );

     /**
     * Identificacion de registro 'SIN INFORMACIN'
     *
     * @return string Identificacin
     */
    static function idSinInfo()
    {
        return 20;
    }

    /**
     * Ajusta formulario generado.
     *
     * @param object $form        Formulario HTML_QuickForm
     * @param object $formbuilder Generador DataObject_FormBuilder
     *
     * @return void
     */
    function postGenerateForm(&$form, &$formbuilder)
    {
        parent::postGenerateForm($form, $formbuilder);

        $gr = array();
        $sel =& $form->getElement('nombre');
        $sel->setSize(30);
        $sel->setMaxlength(150);
        $gr[] =& $sel;

        $sel =& $form->getElement('observaciones');
        $sel->setSize(30);
        $sel->setMaxlength(500);
        $gr[] =& $sel;
    }
}

?>
